// <auto-generated>
//  automatically generated by the FlatBuffers compiler, do not modify
// </auto-generated>

namespace Veneris.Communications
{

using global::System;
using global::System.Collections.Generic;
using global::FlatBuffers;

public struct InitOpal : IFlatbufferObject
{
  private Table __p;
  public ByteBuffer ByteBuffer { get { return __p.bb; } }
  public static void ValidateVersion() { FlatBufferConstants.FLATBUFFERS_2_0_0(); }
  public static InitOpal GetRootAsInitOpal(ByteBuffer _bb) { return GetRootAsInitOpal(_bb, new InitOpal()); }
  public static InitOpal GetRootAsInitOpal(ByteBuffer _bb, InitOpal obj) { return (obj.__assign(_bb.GetInt(_bb.Position) + _bb.Position, _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __p = new Table(_i, _bb); }
  public InitOpal __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public float Frequency { get { int o = __p.__offset(4); return o != 0 ? __p.bb.GetFloat(o + __p.bb_pos) : (float)0.0f; } }
  public int SimType { get { int o = __p.__offset(6); return o != 0 ? __p.bb.GetInt(o + __p.bb_pos) : (int)0; } }
  public int ComputeMode { get { int o = __p.__offset(8); return o != 0 ? __p.bb.GetInt(o + __p.bb_pos) : (int)0; } }
  public uint MaxReflections { get { int o = __p.__offset(10); return o != 0 ? __p.bb.GetUint(o + __p.bb_pos) : (uint)0; } }
  public bool UseExactSpeedOfLight { get { int o = __p.__offset(12); return o != 0 ? 0!=__p.bb.Get(o + __p.bb_pos) : (bool)false; } }
  public bool UseDiffraction { get { int o = __p.__offset(14); return o != 0 ? 0!=__p.bb.Get(o + __p.bb_pos) : (bool)false; } }
  public bool EnableFastMath { get { int o = __p.__offset(16); return o != 0 ? 0!=__p.bb.Get(o + __p.bb_pos) : (bool)false; } }
  public bool GenerateRaysOnLaunch { get { int o = __p.__offset(18); return o != 0 ? 0!=__p.bb.Get(o + __p.bb_pos) : (bool)false; } }
  public bool MultiGPU { get { int o = __p.__offset(20); return o != 0 ? 0!=__p.bb.Get(o + __p.bb_pos) : (bool)false; } }
  public bool LogTrace { get { int o = __p.__offset(22); return o != 0 ? 0!=__p.bb.Get(o + __p.bb_pos) : (bool)false; } }
  public bool MultiTransmitter { get { int o = __p.__offset(24); return o != 0 ? 0!=__p.bb.Get(o + __p.bb_pos) : (bool)false; } }
  public bool UseAntennaGain { get { int o = __p.__offset(26); return o != 0 ? 0!=__p.bb.Get(o + __p.bb_pos) : (bool)false; } }

  public static Offset<Veneris.Communications.InitOpal> CreateInitOpal(FlatBufferBuilder builder,
      float frequency = 0.0f,
      int simType = 0,
      int computeMode = 0,
      uint maxReflections = 0,
      bool useExactSpeedOfLight = false,
      bool useDiffraction = false,
      bool enableFastMath = false,
      bool generateRaysOnLaunch = false,
      bool multiGPU = false,
      bool logTrace = false,
      bool multiTransmitter = false,
      bool useAntennaGain = false) {
    builder.StartTable(12);
    InitOpal.AddMaxReflections(builder, maxReflections);
    InitOpal.AddComputeMode(builder, computeMode);
    InitOpal.AddSimType(builder, simType);
    InitOpal.AddFrequency(builder, frequency);
    InitOpal.AddUseAntennaGain(builder, useAntennaGain);
    InitOpal.AddMultiTransmitter(builder, multiTransmitter);
    InitOpal.AddLogTrace(builder, logTrace);
    InitOpal.AddMultiGPU(builder, multiGPU);
    InitOpal.AddGenerateRaysOnLaunch(builder, generateRaysOnLaunch);
    InitOpal.AddEnableFastMath(builder, enableFastMath);
    InitOpal.AddUseDiffraction(builder, useDiffraction);
    InitOpal.AddUseExactSpeedOfLight(builder, useExactSpeedOfLight);
    return InitOpal.EndInitOpal(builder);
  }

  public static void StartInitOpal(FlatBufferBuilder builder) { builder.StartTable(12); }
  public static void AddFrequency(FlatBufferBuilder builder, float frequency) { builder.AddFloat(0, frequency, 0.0f); }
  public static void AddSimType(FlatBufferBuilder builder, int simType) { builder.AddInt(1, simType, 0); }
  public static void AddComputeMode(FlatBufferBuilder builder, int computeMode) { builder.AddInt(2, computeMode, 0); }
  public static void AddMaxReflections(FlatBufferBuilder builder, uint maxReflections) { builder.AddUint(3, maxReflections, 0); }
  public static void AddUseExactSpeedOfLight(FlatBufferBuilder builder, bool useExactSpeedOfLight) { builder.AddBool(4, useExactSpeedOfLight, false); }
  public static void AddUseDiffraction(FlatBufferBuilder builder, bool useDiffraction) { builder.AddBool(5, useDiffraction, false); }
  public static void AddEnableFastMath(FlatBufferBuilder builder, bool enableFastMath) { builder.AddBool(6, enableFastMath, false); }
  public static void AddGenerateRaysOnLaunch(FlatBufferBuilder builder, bool generateRaysOnLaunch) { builder.AddBool(7, generateRaysOnLaunch, false); }
  public static void AddMultiGPU(FlatBufferBuilder builder, bool multiGPU) { builder.AddBool(8, multiGPU, false); }
  public static void AddLogTrace(FlatBufferBuilder builder, bool logTrace) { builder.AddBool(9, logTrace, false); }
  public static void AddMultiTransmitter(FlatBufferBuilder builder, bool multiTransmitter) { builder.AddBool(10, multiTransmitter, false); }
  public static void AddUseAntennaGain(FlatBufferBuilder builder, bool useAntennaGain) { builder.AddBool(11, useAntennaGain, false); }
  public static Offset<Veneris.Communications.InitOpal> EndInitOpal(FlatBufferBuilder builder) {
    int o = builder.EndTable();
    return new Offset<Veneris.Communications.InitOpal>(o);
  }
  public static void FinishInitOpalBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.InitOpal> offset) { builder.Finish(offset.Value); }
  public static void FinishSizePrefixedInitOpalBuffer(FlatBufferBuilder builder, Offset<Veneris.Communications.InitOpal> offset) { builder.FinishSizePrefixed(offset.Value); }
};


}
